//
//  NisusLogDomain.h
//  NisusCore
//
//  Created by Martin on 2019.03.19.
//  Copyright © 2019 Nisus. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString* NisusLogDomainPropertyName_isEnabled;



@interface NisusLogDomain : NSObject

- (instancetype) initWithDomainName:(NSString*)name enabledPointer:(BOOL*)enabledPtr ;

- (NSString*) domainName ;
@property BOOL isEnabled ;

typedef void (^NisusLogDomainPropertyWatcher)( NisusLogDomain* domain, NSString* name );
@property (copy) NisusLogDomainPropertyWatcher propertyWatcher ; // called any time a domain's property value changes, including enabled

- (void) registerPlistObjectPointer:(id*)optionPtr forPropertyName:(NSString*)name ;
- (void) registerBoolPointer:(BOOL*)valuePtr forPropertyName:(NSString*)name ;

- (void) loadFromUserDefaults ;
- (void) saveToUserDefaults ;

@end
